<script setup>
import { Map, GeolocateControl, NavigationControl } from "maplibre-gl";
import {
  shallowRef,
  onMounted,
  onUnmounted,
  markRaw,
  defineProps,
  defineEmits,
} from "vue";

import data from "../assets/data.json";

console.log(data.features[0].properties.projectTitle);

const emit = defineEmits(["location-changed"]);

const props = defineProps({
  userLocation: String,
  data: Object,
});

const mapContainer = shallowRef(null);
const map = shallowRef(null);

onMounted(() => {
  const apiKey = "3yNQueLqegpytW8I5BFf";

  const initialState = { lng: 7.4374443, lat: 46.948, zoom: 14 };

  console.log(initialState);

  //below -> fix access to location var
  //var initialState = {lng: this.userLocation.coords.longitude, lat: this.userLocation.coords.latitude, zoom: 14  }
  // console.log(props.userLocation);

  map.value = markRaw(
    new Map({
      container: mapContainer.value,
      style: `https://api.maptiler.com/maps/ch-swisstopo-lbm-dark/style.json?key=${apiKey}`,

      center: [initialState.lng, initialState.lat],
      zoom: initialState.zoom,
    })
  );

  map.value.on("load", function () {
    map.value.addSource("projects", {
      type: "geojson",
      data: data,
    });
    map.value.addLayer({
      id: "projects",
      type: "fill",
      source: "projects",
      layout: {},
      paint: {
        "fill-color": "#088",
        "fill-opacity": 0.8,
      },
    });
  });

  map.value.on("click"), function () {};

  map.value.addControl(new NavigationControl(), "top-right");

  var geolocate = new GeolocateControl({
    positionOptions: {
      enableHighAccuracy: true,
    },
    trackUserLocation: true,
  });
  // Add geolocate control to the map.
  map.value.addControl(geolocate);

  geolocate.on("geolocate", function (data) {
    console.log("A geolocate event has occurred");
    console.log(data);
    emit("location-changed", data);
  });
}),
  onUnmounted(() => {
    map.value?.remove();
  });
</script>

<template>
  <div class="map-wrap z-0 relative w-screen h-screen">
    <a
      href="https://www.maptiler.com"
      class="watermark absolute z-50 left-2 top-2"
      ><img
        src="https://api.maptiler.com/resources/logo.svg"
        alt="MapTiler logo"
    /></a>
    <div class="map absolute w-full h-full" ref="mapContainer"></div>
  </div>
</template>

<!-- <style scoped>
.map-wrap {
  position: relative;
  width: 100%;
  height: 100vh;
}

.map {
  position: absolute;
  width: 100%;
  height: 100%;
}

.watermark {
  position: absolute;
  left: 10px;
  top: 10px;
  z-index: 99;
}
</style> -->
